import java.awt.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;
/**
 * <p>Title: Simple dictionary application</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: All free dictionaries project http://www.Dicts.info</p>
 * @version 1.01
 */

class Frame1 extends JFrame {
    JPanel contentPane;
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    JPanel jPanel3 = new JPanel();
    JPanel jPanel4 = new JPanel();

    JLabel jLabel1 = new JLabel();
    JComboBox jComboBox1 = new JComboBox();
    JTextField jTextField1 = new JTextField();
    JButton jButton1 = new JButton();

    JScrollPane jScrollPane1 = new JScrollPane();
    JScrollPane jScrollPane2 = new JScrollPane();
    JTextArea jTextArea1 = new JTextArea();
    JTextArea jTextArea2 = new JTextArea();

    BorderLayout borderLayout2 = new BorderLayout();
    GridLayout gridLayout1 = new GridLayout();
    FlowLayout flowLayout1 = new FlowLayout();
    BorderLayout borderLayout1 = new BorderLayout();

  Map dict1 = new TreeMap();
  Map dict2 = new TreeMap();


public Frame1() {
	try {
	setDefaultCloseOperation(EXIT_ON_CLOSE);
	jbInit();
    cbInit();

		} catch (Exception exception) {
			exception.printStackTrace();
		}
 }

private void cbInit() throws Exception {
   File pathName = new File("data");
   if(pathName.exists() && pathName.isDirectory()){
   String[] fN = pathName.list();
   if(fN.length==0){
     jComboBox1.addItem("0 available");
     String warn="No dictionaries found!\nCopy dictionaries into \"data\" directory.\n";
     warn+="For example copy english-french.txt file\ninto \"data\" directory \nand restart this application.\n";
     jTextArea1.setText(warn);
   }
   else{
     int cnt=0;
     for(int i=0;i<fN.length;i++){
	 if(fN[i].contains(".txt"))cnt++;
       }
     jComboBox1.addItem(cnt+" available");
     for(int i=0;i<fN.length;i++){
     if(fN[i].contains(".txt"))jComboBox1.addItem(fN[i]);
       }
   }
   jTextField1.requestFocus();
   }
   else{
	   jComboBox1.addItem("0 available");
	   jTextArea1.setText("Data directory does not exist!");
	   }
}
    private void jbInit() throws Exception {
        contentPane = (JPanel) getContentPane();
        contentPane.setLayout(borderLayout1);
        setSize(new Dimension(600, 420));
        setTitle("Simple Dictionary Application 1.01");
        jPanel1.setLayout(borderLayout2);
        jPanel2.setBackground(Color.lightGray);
        jPanel2.setBorder(null);
        jPanel2.setLayout(flowLayout1);
        jPanel3.setBorder(null);
        jPanel3.setLayout(gridLayout1);
        jButton1.setText("Search");
        jButton1.addActionListener(new Frame1_jButton1_actionAdapter(this));
        jTextArea2.setBackground(Color.white);
        jTextArea2.setBorder(null);
        jTextArea2.setText("");
        jScrollPane1.setBorder(BorderFactory.createEtchedBorder());
        jTextArea1.setBackground(Color.white);
        jTextArea1.setBorder(null);
        jTextArea1.setEditable(false);
        jTextArea1.setText("");
        jTextArea1.setFont(new java.awt.Font("Default", Font.PLAIN, 14));
        jTextArea2.setFont(new java.awt.Font("Default", Font.PLAIN, 14));
        jScrollPane2.setBorder(BorderFactory.createEtchedBorder());
        jLabel1.setText("Dictionary");
        jPanel4.setBackground(Color.lightGray);

        jTextField1.addActionListener(new Frame1_jTextField1_actionAdapter(this));
        jComboBox1.addActionListener(new Frame1_jComboBox1_actionAdapter(this));

        jTextField1.setPreferredSize(new Dimension(100, 25));
        jComboBox1.setPreferredSize(new Dimension(210, 25));
        contentPane.add(jPanel1, java.awt.BorderLayout.CENTER);
        jPanel1.add(jPanel2, java.awt.BorderLayout.NORTH);
        jPanel4.add(jLabel1);
        jPanel4.add(jComboBox1);
        jPanel4.add(jTextField1);
        jPanel4.add(jButton1);
        jPanel2.add(jPanel4, null);
        jPanel1.add(jPanel3, java.awt.BorderLayout.CENTER);
        jPanel3.add(jScrollPane1);
        jScrollPane1.getViewport().add(jTextArea1);
        jPanel3.add(jScrollPane2, null);
        jScrollPane2.getViewport().add(jTextArea2);
        jPanel3.add(jScrollPane2, null);
    }


void jButton1_actionPerformed(ActionEvent e) {
search(jTextField1.getText());
jTextField1.requestFocus();
jTextField1.selectAll();
  }

  void jComboBox1_actionPerformed(ActionEvent e) {
String word=(String)jComboBox1.getSelectedItem();
if(word!=null && word.contains(".txt"))readfile(word);
  }

  void jTextField1_actionPerformed(ActionEvent e) {
    search(jTextField1.getText());
    jTextField1.requestFocus();
    jTextField1.selectAll();
  }




// This method searches in the selected dictionary.
public void search(String word){
if(word.length()>0){
  String res1="";
  String res2="";
  int pos=0;
  while(dict1.containsKey(word+"-"+pos)){
  res1+=word+" = "+dict1.get(word+"-"+pos)+"\n";
   pos++; }

  pos=0;
 while(dict2.containsKey(word+"-"+pos)){
 res2+=word+" = "+dict2.get(word+"-"+pos)+"\n";
 pos++; }
 if(res1.equals(""))res1="Nothing found";
 if(res2.equals(""))res2="Nothing found";
 jTextArea1.setText(res1);
 jTextArea2.setText(res2);}
}

//This method reads dictionary from data directory into memory.
//Translations are filled into two TreeMap data structures.
//TreeMaps need a lot of memory but searching is very fast.
  public void readfile(String word){
    try {
      File fil= new File("data/"+word);
      String mes="Loading "+word+" ";
      System.out.println(mes);
      dict1 = new TreeMap();
      dict2 = new TreeMap();
      int cnt=0;
      int cnt2=0;
      int cnt3=0;
      BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(fil),"UTF-8"));
      String str; while ((str = in.readLine())!=null){//*******************
      cnt++;cnt2++;if(cnt>5000){cnt=0;System.out.print('.');
      }
      String st[]=str.split("\t");
      String note="";
      if(st.length>1 & st[0].length()>0 &&  st[1].length()>0){
        int pos=0;
        cnt3++;
        if(st.length>2)note+=st[2];
        if(st.length>3)note+=st[3];
        while(dict1.containsKey(st[0]+"-"+pos)){pos++;}
        dict1.put(st[0]+"-"+pos,st[1]+"	"+note);
        pos=0;
        while(dict2.containsKey(st[1]+"-"+pos)){pos++;}
        dict2.put(st[1]+"-"+pos,st[0]+"	"+note);
       }
      }//************************
     System.out.println("\nRecords: "+cnt2+" read - "+cnt3+" loaded");
     in.close();
     jTextField1.requestFocus();
      }
     catch(IOException e){System.out.println("Error: " + e);}
    }


}


class Frame1_jTextField1_actionAdapter implements ActionListener {
    private Frame1 adaptee;
    Frame1_jTextField1_actionAdapter(Frame1 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jTextField1_actionPerformed(e);
    }
}


class Frame1_jButton1_actionAdapter implements ActionListener {
    private Frame1 adaptee;
    Frame1_jButton1_actionAdapter(Frame1 adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.jButton1_actionPerformed(e);
    }
}

class Frame1_jComboBox1_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jComboBox1_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jComboBox1_actionPerformed(e);
  }
}



public class SDA {
boolean packFrame = false;
public SDA() {
	Frame1 frame = new Frame1();
	if (packFrame) frame.pack();
	else frame.validate();

	// Center the window
	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	Dimension frameSize = frame.getSize();
	if (frameSize.height > screenSize.height) {frameSize.height = screenSize.height;}
	if (frameSize.width > screenSize.width) { frameSize.width = screenSize.width;}
	frame.setLocation((screenSize.width - frameSize.width) / 2,(screenSize.height - frameSize.height) / 2);
	frame.setVisible(true);
    }

public static void main(String[] args) {
 SwingUtilities.invokeLater(new Runnable() {
 public void run() {
  try {
    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
   } catch (Exception exception) {exception.printStackTrace();}

 new SDA();
 }
 });

 }
}
